library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;


entity compito1907 is
	port (rst,clk,nw: in std_logic;
	din: in std_logic_vector(7 downto 0);
	ris: out std_logic_vector(7 downto 0);
	fine: out std_logic);
end compito1907;

architecture beh of compito1907 is
type stati is (idle, let0, let1andor,let1addsub,let1div,andor,addsub,div);
signal s: stati;
signal en_let0,en_let1,en_andor,en_addsub,en_div: std_logic;
signal d0,d1: std_logic_vector(7 downto 0);
signal op: std_logic_vector(2 downto 0);
 signal conta: integer range 0 to 3;
begin  
	
	
	process(clk,rst)
	begin
		if rst = '1' then s<= idle;
		elsif clk'event and clk='0' then
			case s is
				when idle => if nw = '1' then 
								s <= let0;
							else s <= idle;
							end if;
				when let0 => case op is
								when  "000" | "001" => s <= let1addsub;
								when  "010" | "011" => s<= let1andor;
								when  "100" => s<= let1div;
								when others => s <= idle;
							end case;
				when let1addsub => s <= addsub;
				when let1andor => s <= andor;
				when let1div => s <= div;
				when addsub =>  if conta = 1 then 
									s<= idle;
								else s <= addsub;
								end if;	
				
				when div => if conta = 3 then 
									s<= idle;
								else s <= div;
								end if;
				when others =>  s <= idle;
			end case;
		end if;	
	end process;
	
	en_let0 <= '1' when s= let0 else '0';
		
	en_let1 <= '1' when s = let1andor or s = let1addsub or s = let1div else '0';
		
	en_andor <= '1' when s= andor else '0';
	
	en_addsub <= '1' when s = addsub else '0';
	
	en_div <= '1' when s = div else '0';
		
	process(clk)
	begin
		if clk'event and clk='0' then
			if nw='1' then op <= din(2 downto 0);
			end if;
			
			if en_let0 = '1' then 
				d0 <= din;
			end if;
			
			if en_let1 = '1' then 
				d1 <= din; 
				conta <= 0;
			end if;
			
			if en_andor = '1' then
				if op(0) = '0'  then -- and
					ris <= d0 and d1;
				else ris <= d0 or d1;  -- or
				end if;
			end if;
			
			if en_addsub = '1' then
				if conta < 1 then 
					conta <= 1;
				else if op(0) = '0' then -- add
					   ris <= d0 +d1;
				     else ris <= d0 - d1; -- sub
					 end if;
				end if;
			end if;	
			
		  if en_div = '1' then
			  if conta < 3 then
				  conta <= conta +1;
			  else ris <= conv_std_logic_vector(conv_integer(d0)/conv_integer(d1),8);
		      end if;
		  end if;
		  
		  if en_andor='1' or (en_addsub='1' and conta=1) or (en_div='1' and conta=3) then  fine <= '1';
		  else fine <= '0';
		  end if;
	  end if;
			  
		end process;
end beh;
		
			
			